Index: contrib/MacPorts_Framework/BetterAuthorizationSampleLib.c
===================================================================
--- contrib/MacPorts_Framework/BetterAuthorizationSampleLib.c	(revision 40518)
+++ contrib/MacPorts_Framework/BetterAuthorizationSampleLib.c	(revision 65491)
@@ -48,4 +48,5 @@
 // "BetterAuthorizationSampleLib.h".
 
+
 #define BAS_PRIVATE 1
 
@@ -78,5 +79,5 @@
 enum {
     kIdleTimeoutInSeconds     = 120,        // if we get no requests in 2 minutes, we quit
-    kWatchdogTimeoutInSeconds = 65          // any given request must be completely in 65 seconds
+    kWatchdogTimeoutInSeconds = 500000      // any given request must be completed in ~5 days (is this ok?)
 };
 
@@ -94,10 +95,10 @@
 //    can be sent as an architecture-neutral uint32_t.
 
-#define kBASMaxNumberOfKBytes			(1024 * 1024)
+#define kBASMaxNumberOfKBytes           (1024 * 1024)
 
 // A hard-wired file system path for the UNIX domain socket; %s is the placeholder 
 // for the bundle ID (in file system representation).
 
-#define kBASSocketPathFormat			"/var/run/%s.socket"
+#define kBASSocketPathFormat            "/var/run/%s.socket"
 
 // The key used to get our describe our socket in the launchd property list file.
@@ -118,7 +119,7 @@
             break
     switch (errNum) {
-		case noErr:
-			retval = 0;
-			break;
+        case noErr:
+            retval = 0;
+            break;
         case kENORSRCErr:
             retval = ESRCH;                 // no ENORSRC on Mac OS X, so use ESRCH
@@ -129,7 +130,7 @@
         CASE(EDEADLK);
         CASE(EAGAIN);
-		case kEOPNOTSUPPErr:
-			retval = ENOTSUP;
-			break;
+        case kEOPNOTSUPPErr:
+            retval = ENOTSUP;
+            break;
         CASE(EPROTO);
         CASE(ETIME);
@@ -146,10 +147,10 @@
         default:
             if ( (errNum <= kEPERMErr) && (errNum >= kENOMSGErr) ) {
-				retval = (-3200 - errNum) + 1;				// OT based error
+                retval = (-3200 - errNum) + 1;              // OT based error
             } else if ( (errNum >= errSecErrnoBase) && (errNum <= (errSecErrnoBase + ELAST)) ) {
-                retval = (int) errNum - errSecErrnoBase;	// POSIX based error
+                retval = (int) errNum - errSecErrnoBase;    // POSIX based error
             } else {
-				retval = (int) errNum;						// just return the value unmodified
-			}
+                retval = (int) errNum;                      // just return the value unmodified
+            }
     }
     #undef CASE
@@ -1921,37 +1922,43 @@
     // We install the job disabled, then enable it as the last step.
 
-    "	<key>Disabled</key>\n"
-    "	<true/>\n"
+    "   <key>Disabled</key>\n"
+    "   <true/>\n"
 
     // Use the bundle identifier as the job label.
 
-    "	<key>Label</key>\n"
-    "	<string>%s</string>\n"
+    "   <key>Label</key>\n"
+    "   <string>%s</string>\n"
 
     // Use launch on demaind.
 
-    "	<key>OnDemand</key>\n"
-    "	<true/>\n"
-
-	// We don't want our helper tool to be respawned every 10 seconds
-	// after a faliure ... hopefully this won't ALSO prevent us from
-	// rerunning the helper tool without rebooting the machine
-//	"	<key>LaunchOnlyOnce</key>\n"
-//	"	<true/>\n"
-
-    // There are no program arguments, other that the path to the helper tool itself.
+    "   <key>OnDemand</key>\n"
+    "   <true/>\n"
+
+    // We don't want our helper tool to be respawned every 10 seconds
+    // after a faliure ... hopefully this won't ALSO prevent us from
+    // rerunning the helper tool without rebooting the machine
+    "   <key>LaunchOnlyOnce</key>\n"
+    "   <true/>\n"
+
+    // There are no program arguments, other that the path to the helper tool itself
+    // but we must force it to run using the i386 binary if the Framework is
+    // being used as a i386 binary.
     //
     // IMPORTANT
     // kBASToolPathFormat embeds a %s
 
-    "	<key>ProgramArguments</key>\n"
-    "	<array>\n"
-    "		<string>" kBASToolPathFormat "</string>\n"
-    "	</array>\n"
+    "   <key>ProgramArguments</key>\n"
+    "   <array>\n"
+#ifdef __i386__
+    "       <string>/usr/bin/arch</string>\n"
+    "       <string>-i386</string>\n"
+#endif
+    "       <string>" kBASToolPathFormat "</string>\n"
+    "   </array>\n"
 
     // The tool is required to check in with launchd.
 
-    "	<key>ServiceIPC</key>\n"
-    "	<true/>\n"
+    "   <key>ServiceIPC</key>\n"
+    "   <true/>\n"
 
     // This specifies the UNIX domain socket used to launch the tool, including 
@@ -1961,18 +1968,18 @@
     // kBASSocketPathFormat embeds a %s
 
-    "	<key>Sockets</key>\n"
-    "	<dict>\n"
-    "		<key>" kLaunchDSocketDictKey "</key>\n"
-    "		<dict>\n"
-    "			<key>SockFamily</key>\n"
-    "			<string>Unix</string>\n"
-    "			<key>SockPathMode</key>\n"
-    "			<integer>438</integer>\n"
-    "			<key>SockPathName</key>\n"
-    "			<string>" kBASSocketPathFormat "</string>\n"
-    "			<key>SockType</key>\n"
-    "			<string>Stream</string>\n"
-    "		</dict>\n"
-    "	</dict>\n"
+    "   <key>Sockets</key>\n"
+    "   <dict>\n"
+    "       <key>" kLaunchDSocketDictKey "</key>\n"
+    "       <dict>\n"
+    "           <key>SockFamily</key>\n"
+    "           <string>Unix</string>\n"
+    "           <key>SockPathMode</key>\n"
+    "           <integer>438</integer>\n"
+    "           <key>SockPathName</key>\n"
+    "           <string>" kBASSocketPathFormat "</string>\n"
+    "           <key>SockType</key>\n"
+    "           <string>Stream</string>\n"
+    "       </dict>\n"
+    "   </dict>\n"
     "</dict>\n"
     "</plist>\n"
@@ -2461,2 +2468,22 @@
     return retval;
 }
+
+extern void BASTerminateCommand (
+                           AuthorizationRef			auth, 
+                           const char *				bundleID, 
+                           const char *             installToolPath
+)
+// Terminate the HelperTool.
+{
+    // Pre-conditions
+    
+    assert(auth != NULL);
+    assert(bundleID != NULL);
+    assert(installToolPath != NULL);
+    
+    // Run the install tool as root using AuthorizationExecuteWithPrivileges.   
+    RunInstallToolAsRoot(auth, installToolPath, kBASInstallToolTerminateCommand, bundleID, NULL);
+    
+    return;
+}
+
Index: contrib/MacPorts_Framework/BetterAuthorizationSampleLib.h
===================================================================
--- contrib/MacPorts_Framework/BetterAuthorizationSampleLib.h	(revision 40518)
+++ contrib/MacPorts_Framework/BetterAuthorizationSampleLib.h	(revision 65491)
@@ -739,4 +739,10 @@
 );
 
+extern void BASTerminateCommand(
+    AuthorizationRef			auth, 
+    const char *				bundleID, 
+    const char *                installToolPath
+);
+
 /////////////////////////////////////////////////////////////////
 #pragma mark ***** Utility Routines
@@ -764,4 +770,5 @@
     #define kBASInstallToolInstallCommand "install"
     #define kBASInstallToolEnableCommand  "enable"
+    #define kBASInstallToolTerminateCommand  "terminate"
 
 	// Magic values used to bracket the process ID returned by the install tool.
Index: contrib/MacPorts_Framework/BetterAuthorizationSampleLibInstallTool.c
===================================================================
--- contrib/MacPorts_Framework/BetterAuthorizationSampleLibInstallTool.c	(revision 40518)
+++ contrib/MacPorts_Framework/BetterAuthorizationSampleLibInstallTool.c	(revision 65491)
@@ -396,4 +396,22 @@
 }
 
+static int TerminateCommand(
+    const char					*bundleID
+)
+// Utility function to call through to RunLaunchCtl in order to terminate a job
+// given by the path contructed from the (const char *) bundleID.
+{
+	int		err;
+	char	plistPath[PATH_MAX];
+	
+	// Pre-condition.
+	assert(bundleID != NULL);
+	
+	(void) snprintf(plistPath, sizeof(plistPath), kBASPlistPathFormat, bundleID);
+	err = RunLaunchCtl(false, "unload", plistPath);
+    
+	return err;
+}
+
 int main(int argc, char **argv)
 {
@@ -454,8 +472,15 @@
 				err = EINVAL;
 			}
-		} else {
-			fprintf(stderr, "usage2\n");
-			err = EINVAL;
-		}
+		} else if (strcmp(argv[1], kBASInstallToolTerminateCommand) == 0) {
+            if (argc == 3) {
+				err = TerminateCommand(argv[2]);
+			} else {
+				fprintf(stderr, "usage4\n");
+				err = EINVAL;
+			}
+        } else {
+            fprintf(stderr, "usage2\n");
+            err = EINVAL;
+        }
 	}
 
Index: contrib/MacPorts_Framework/MPInterpreter.h
===================================================================
--- contrib/MacPorts_Framework/MPInterpreter.h	(revision 40518)
+++ contrib/MacPorts_Framework/MPInterpreter.h	(revision 65491)
@@ -53,5 +53,4 @@
 #define	MPPackage				@"macports"
 #define MPPackageVersion		@"1.0"
-#define MP_DEFAULT_PKG_PATH		@"/Library/Tcl"
 #define TCL_RETURN_CODE			@"return code"
 #define TCL_RETURN_STRING		@"return string"
@@ -86,7 +85,4 @@
 
 
-
-
-
 /*!
  @class MPInterpreter
@@ -105,6 +101,16 @@
 }
 
++(NSString*) PKGPath;
+
++(void) setPKGPath:(NSString*)newPath;
+
++(void) terminateMPHelperTool;
+
++(NSTask*) task;
+
 //Internal methods
 -(BOOL) setOptionsForNewTclPort:(NSArray *)options;
+
+-(BOOL) resetTclInterpreterWithPath:(NSString *)path;
 
 /*!
@@ -199,4 +205,5 @@
 - (BOOL)checkIfAuthorized;
 -(NSString *)evaluateStringWithMPHelperTool:(NSString *)statement error:(NSError **)mportError;
+-(NSString *)evaluateStringWithMPPortProcess:(NSString *)statement error:(NSError **)mportError;
 
 @end
Index: contrib/MacPorts_Framework/MPInterpreter.m
===================================================================
--- contrib/MacPorts_Framework/MPInterpreter.m	(revision 40518)
+++ contrib/MacPorts_Framework/MPInterpreter.m	(revision 65491)
@@ -35,10 +35,11 @@
 
 #import "MPInterpreter.h"
+#import "MPMacPorts.h"
 #include "BetterAuthorizationSampleLib.h"
 #include "MPHelperCommon.h"
 #include "MPHelperNotificationsProtocol.h"
 static AuthorizationRef internalMacPortsAuthRef;
-
-
+static NSString* PKGPath = @"/Library/Tcl";
+static NSTask* aTask;
 
 #pragma mark -
@@ -46,5 +47,5 @@
 @implementation MPInterpreter
 
-#pragma mark Notifications Code 
+#pragma mark Notifications Code
 int Notifications_Send(int objc, Tcl_Obj *CONST objv[], int global, Tcl_Interp *interpreter) {
 	NSString *name;
@@ -165,4 +166,18 @@
 static NSString * tclInterpreterPkgPath = nil;
 
++(NSString*) PKGPath {
+	return PKGPath;
+}
+
++(void) setPKGPath:(NSString*)newPath {
+    if([PKGPath isNotEqualTo:newPath]) {
+        [PKGPath release];
+        PKGPath = [newPath copy];
+        //I should check if interp is nil. *not needed now
+        MPInterpreter *interp = (MPInterpreter*) [[[NSThread currentThread] threadDictionary] objectForKey:@"sharedMPInterpreter"];
+        [interp resetTclInterpreterWithPath:PKGPath];
+    }
+}
+
 #pragma mark -
 #pragma mark Internal Methods
@@ -185,5 +200,5 @@
 	
 	if (path == nil)
-		path = MP_DEFAULT_PKG_PATH;
+		path = PKGPath;
 	
 	
@@ -248,5 +263,5 @@
 	
 	if (tclInterpreterPkgPath == nil) 
-		result = [self initTclInterpreter:&_interpreter withPath:MP_DEFAULT_PKG_PATH];
+		result = [self initTclInterpreter:&_interpreter withPath:PKGPath];
 	else 
 		result = [self initTclInterpreter:&_interpreter withPath:tclInterpreterPkgPath];
@@ -260,7 +275,11 @@
 } 
 
+-(BOOL) resetTclInterpreterWithPath:(NSString*) path {
+    Tcl_DeleteInterp(_interpreter);
+    return [self initTclInterpreter:&_interpreter withPath:PKGPath];
+}
+
 - (id) initWithPkgPath:(NSString *)path portOptions:(NSArray *)options {
 	if (self = [super init]) {
-		
 		[self initTclInterpreter:&_interpreter withPath:path];
 		
@@ -285,24 +304,21 @@
 #pragma mark API methods
 - (id) init {
-	return [self initWithPkgPath:MP_DEFAULT_PKG_PATH portOptions:nil];
+	return [self initWithPkgPath:PKGPath portOptions:nil];
 }
 
 + (MPInterpreter*)sharedInterpreterWithPkgPath:(NSString *)path {
-	@synchronized(self) {
-		if ([[[NSThread currentThread] threadDictionary] objectForKey:@"sharedMPInterpreter"] == nil) {
-			[[self alloc] initWithPkgPath:path portOptions:nil]; // assignment not done here
-		}
-	}
-	return [[[NSThread currentThread] threadDictionary] objectForKey:@"sharedMPInterpreter"];
+	return [self sharedInterpreterWithPkgPath:path portOptions:nil];
 }
 
 + (MPInterpreter*)sharedInterpreter{
-	return [self sharedInterpreterWithPkgPath:MP_DEFAULT_PKG_PATH];
-}
-
-
+	return [self sharedInterpreterWithPkgPath:PKGPath];
+}
 
 + (MPInterpreter*)sharedInterpreterWithPkgPath:(NSString *)path portOptions:(NSArray *)options {
 	@synchronized(self) {
+        if ([PKGPath isNotEqualTo:path]) {
+            [self setPKGPath:path];
+        }
+        
 		if ([[[NSThread currentThread] threadDictionary] objectForKey:@"sharedMPInterpreter"] == nil) {
 			[[self alloc] initWithPkgPath:path portOptions:options]; // assignment not done here
@@ -439,28 +455,22 @@
 
 - (NSString *)evaluateStringWithPossiblePrivileges:(NSString *)statement error:(NSError **)mportError {
-	
-	
-	
 	//N.B. I am going to insist that funciton users not pass in nil for the
 	//mportError parameter
-	NSString * firstResult;
-	NSString * secondResult;
-	
-	*mportError = nil;
-	firstResult = [self evaluateStringAsString:statement error:mportError];
-	
-	//Because of string results of methods like mportsync (which returns the empty string)
-	//the only way to truly check for an error is to check the mportError parameter.
-	//If it is nil then there was no error, if not we re-evaluate with privileges using
-	//the helper tool
-	
-	if ( *mportError != nil) {
-		*mportError = nil; 
-		secondResult = [self evaluateStringWithMPHelperTool:statement error:mportError];
-		
-		return secondResult;
-	}
-	
-	return firstResult;
+	NSString * result;
+	
+    [[MPNotifications sharedListener] 
+     sendIPCNotification:@"MPInfoNotification_&MP&_stdout_&MP&_None_&MP&_Starting up"];
+    
+    // Is this the best way to know if the running user can use macports without privileges?
+    if ([[NSFileManager defaultManager] isWritableFileAtPath:PKGPath]) {
+        result = [self evaluateStringWithMPPortProcess:statement error:mportError];
+    } else {
+        result = [self evaluateStringWithMPHelperTool:statement error:mportError];
+    }
+
+    [[MPNotifications sharedListener] 
+     sendIPCNotification:@"MPInfoNotification_&MP&_stdout_&MP&_None_&MP&_Shutting down"];
+    
+	return result;
 }
 
@@ -584,36 +594,8 @@
 		//a noErr then response dictionary cannot be nil since everything went ok. 
 		//Hence I'm only checking for errors WITHIN the following blocks ...
-		if (err == noErr) {
-			err = BASExecuteRequestInHelperTool(internalMacPortsAuthRef, 
-												kMPHelperCommandSet, 
-												(CFStringRef) bundleID, 
-												(CFDictionaryRef) request, 
-												&response);
-			if (err == noErr){// retrieve result here if available
-				if( response != NULL)
-					result = (NSString *) (CFStringRef) CFDictionaryGetValue(response, CFSTR(kTclStringEvaluationResult));
-			}
-			else { //If we executed unsuccessfully
-				if (mportError != NULL) {
-					NSError * undError = [[[NSError alloc] initWithDomain:NSOSStatusErrorDomain 
-																	 code:err 
-																 userInfo:[NSDictionary dictionaryWithObjectsAndKeys:
-																		   NSLocalizedString(@"Check error code for OSStatus returned",@""), 
-																		   NSLocalizedDescriptionKey,
-																		   nil]] autorelease];
-					
-					*mportError = [[[NSError alloc] initWithDomain:MPFrameworkErrorDomain 
-															  code:MPHELPINSTFAILED 
-														  userInfo:[NSDictionary dictionaryWithObjectsAndKeys:
-																	NSLocalizedString(@"Unable to execute MPHelperTool successfuly", @""), 
-																	NSLocalizedDescriptionKey,
-																	undError, NSUnderlyingErrorKey,
-																	NSLocalizedString(@"BASExecuteRequestInHelperTool execution failed", @""),
-																	NSLocalizedFailureReasonErrorKey,
-																	nil]] autorelease];
-				}
-			}
-		}
-		else {//This means FixFaliure failed ... Report that in returned error
+        //
+        // NOTE: We don't automatically retry as the user wants to have a consistent cancel 
+        //      action (i.e. terminate the process when he wants to)
+		if (err != noErr) {//This means FixFaliure failed ... Report that in returned error
 			if (mportError != NULL) {
 				//I'm not sure of exactly how to report this error ... 
@@ -644,4 +626,77 @@
 }
 
+- (NSString *) evaluateStringWithMPPortProcess:(NSString *) statement error:(NSError **)mportError {
+    aTask = [[NSTask alloc] init];
+    NSMutableArray *args = [NSMutableArray array];
+    
+    /* set arguments */
+    [args addObject:PKGPath];
+    [aTask setCurrentDirectoryPath:[[NSBundle bundleForClass:[self class]] resourcePath]];
+    [aTask setLaunchPath:[[NSBundle bundleForClass:[self class]] pathForResource:@"MPPortProcess" ofType:@""]];
+    [aTask setArguments:args];
+    [aTask launch];
+    
+    NSConnection *notificationsConnection = [NSConnection defaultConnection];
+    // Vending MPNotifications sharedListener
+    [notificationsConnection setRootObject:[MPNotifications sharedListener]];
+    
+    // Register the named connection
+    if ( [notificationsConnection registerName:@"MPNotifications"] ) {
+        NSLog( @"Successfully registered connection with port %@", 
+              [[notificationsConnection receivePort] description] );
+    } else {
+        NSLog( @"Name used by %@", 
+              [[[NSPortNameServer systemDefaultPortNameServer] portForName:@"MPNotifications"] description] );
+    }
+    
+    
+    id theProxy;
+    do {
+        theProxy = [NSConnection
+                       rootProxyForConnectionWithRegisteredName:@"MPPortProcess"
+                       host:nil];
+    } 
+    while (theProxy == nil);
+    
+    [theProxy evaluateString:statement];
+    [aTask waitUntilExit];
+    
+    int status = [aTask terminationStatus];
+    
+    if (status != TCL_OK) {
+        NSLog(@"Task failed. Code: %i", status);
+    }
+    [[notificationsConnection receivePort] invalidate];
+    
+    return nil;
+}
+
++ (NSTask*) task {
+    return aTask;
+}
+
++ (void) terminateMPHelperTool {
+    NSString *      bundleID;
+
+    //In order to make the framework work normally by default ... we do a bare initialization
+    //of internalMacPortsAuthRef if the delegate hasn't iniitialzed it already
+    if (internalMacPortsAuthRef == NULL) {
+        OSStatus res = AuthorizationCreate (NULL, kAuthorizationEmptyEnvironment, kAuthorizationFlagDefaults, &internalMacPortsAuthRef);
+        assert(res == noErr);
+    }
+
+    NSBundle * mpBundle = [NSBundle bundleForClass:[self class]];
+    NSString * installToolPath = [mpBundle pathForResource:@"MPHelperInstallTool" ofType:nil];
+    bundleID = [mpBundle bundleIdentifier];
+
+    BASSetDefaultRules(internalMacPortsAuthRef, 
+                        kMPHelperCommandSet, 
+                        (CFStringRef) bundleID, 
+                        NULL);
+    BASTerminateCommand(internalMacPortsAuthRef, 
+                        [bundleID UTF8String], 
+                        [installToolPath UTF8String]);
+    return;
+}
 
 #pragma mark -
Index: contrib/MacPorts_Framework/MPMacPorts.h
===================================================================
--- contrib/MacPorts_Framework/MPMacPorts.h	(revision 40518)
+++ contrib/MacPorts_Framework/MPMacPorts.h	(revision 65491)
@@ -77,4 +77,8 @@
 }
 
++ (NSString*) PKGPath;
+
++ (void) setPKGPath:(NSString*)newPath;
+
 /*!
  @brief Returns an MPMacPorts object that represents the MacPorts system on user's machine.
@@ -82,8 +86,4 @@
 + (MPMacPorts *)sharedInstance;
 
-+ (MPMacPorts *)sharedInstanceWithPortOptions:(NSArray *)options;
-
-//Names of messages below are subject to change
-+ (MPMacPorts *)sharedInstanceWithPkgPath:(NSString *)path;
 + (MPMacPorts *)sharedInstanceWithPkgPath:(NSString *)path portOptions:(NSArray *)options;
 - (id) initWithPkgPath:(NSString *)path portOptions:(NSArray *)options;
@@ -222,4 +222,5 @@
 -(BOOL) authorizationMode;
 
+- (void) cancelCurrentCommand;
 
 //Notifications stuff for private use and testing purposes
Index: contrib/MacPorts_Framework/MPMacPorts.m
===================================================================
--- contrib/MacPorts_Framework/MPMacPorts.m	(revision 40518)
+++ contrib/MacPorts_Framework/MPMacPorts.m	(revision 65491)
@@ -40,9 +40,7 @@
 @implementation MPMacPorts
 
-
 - (id) init {
-	return [self initWithPkgPath:MP_DEFAULT_PKG_PATH portOptions:nil];
-}
-
+	return [self initWithPkgPath:[MPInterpreter PKGPath] portOptions:nil];
+}
 
 - (id) initWithPkgPath:(NSString *)path portOptions:(NSArray *)options {
@@ -54,25 +52,40 @@
 }
 
++(NSString*) PKGPath {
+	return [MPInterpreter PKGPath];
+}
+
++(void) setPKGPath:(NSString*)newPath {
+    [MPInterpreter setPKGPath:newPath];
+}
+
+- (void) cancelCurrentCommand {
+    if ([[NSFileManager defaultManager] isWritableFileAtPath:[MPInterpreter PKGPath]]) {
+        NSLog(@"Terminating MPPortProcess");
+        NSTask *task = [MPInterpreter task];
+        if(task != nil && [task isRunning]) {
+            [task terminate];
+        }
+    } else {
+        NSLog(@"Terminating MPHelperTool");
+        [MPInterpreter terminateMPHelperTool];
+    }
+}
+
 + (MPMacPorts *)sharedInstance {
-	return [self sharedInstanceWithPkgPath:MP_DEFAULT_PKG_PATH];
-}
-
-+ (MPMacPorts *)sharedInstanceWithPortOptions:(NSArray *)options {
-	return [self sharedInstanceWithPkgPath:MP_DEFAULT_PKG_PATH portOptions:options];
+	return [self sharedInstanceWithPkgPath:[MPInterpreter PKGPath] portOptions:nil];
 }
 
 + (MPMacPorts *)sharedInstanceWithPkgPath:(NSString *)path portOptions:(NSArray *)options {
 	@synchronized(self) {
+		if ([path isEqual:nil]) {
+			path = [MPInterpreter PKGPath];
+		}
+		if ([[MPInterpreter PKGPath] isNotEqualTo:path]) {
+            [self setPKGPath:path];
+        }
+		
 		if ([[[NSThread currentThread] threadDictionary] objectForKey:@"sharedMPMacPorts"] == nil) {
 			[[self alloc] initWithPkgPath:path portOptions:options ]; // assignment not done here
-		}
-	}
-	return [[[NSThread currentThread] threadDictionary] objectForKey:@"sharedMPMacPorts"];
-}
-
-+ (MPMacPorts *)sharedInstanceWithPkgPath:(NSString *)path {
-	@synchronized(self) {
-		if ([[[NSThread currentThread] threadDictionary] objectForKey:@"sharedMPMacPorts"] == nil) {
-			[[self alloc] initWithPkgPath:path portOptions:nil ]; // assignment not done here
 		}
 	}
Index: contrib/MacPorts_Framework/MPMacPortsTest.m
===================================================================
--- contrib/MacPorts_Framework/MPMacPortsTest.m	(revision 40518)
+++ contrib/MacPorts_Framework/MPMacPortsTest.m	(revision 65491)
@@ -66,5 +66,5 @@
 //Ask Randall about what exactly port tree path is
 -(void) testPathToPortIndex {
-	NSURL *pindex = [testPort pathToPortIndex:@"file:///Users/Armahg/macportsbuild/build1/"];
+	NSURL *pindex = [testPort pathToPortIndex:@"file:///Users/juanger/local/macportsbuild/branch-unprivileged/"];
 	STAssertNotNil(pindex, @"URL for port index should not be nil");
 }
@@ -75,5 +75,12 @@
 }
 
+-(void) testPKGPathChange {
+    NSString *newPkgPath = @"/Users/juanger/local/macportsbuild/branch-unprivileged/Library/Tcl";
 
+    STAssertEqualObjects([MPInterpreter PKGPath], @"/Library/Tcl", @"Initialy, the PKGPath should be /Library/Tcl");
+
+    [MPMacPorts sharedInstanceWithPkgPath:newPkgPath portOptions:nil];
+    STAssertEqualObjects([MPInterpreter PKGPath], newPkgPath, @"The global PKGPath should change as needed");
+}
 /*-(void) testSync {
 	NSError * syncError = nil;
Index: contrib/MacPorts_Framework/MPPort.h
===================================================================
--- contrib/MacPorts_Framework/MPPort.h	(revision 40518)
+++ contrib/MacPorts_Framework/MPPort.h	(revision 65491)
@@ -141,4 +141,11 @@
 - (void)deactivateWithVersion:(NSString *)version error:(NSError**)mpError;
 
+/*!
+ @brief Upgrades an outdated MPPort.
+ @discussion Only installed and active ports
+ should be upgraded
+ */
+- (void)upgradeWithError:(NSError**)mpError;
+
 
 /*!
@@ -291,3 +298,4 @@
 //Even more generic method to execute a Tcl command with any given number of args
 - (void)execPortProc:(NSString *)procedure withParams:(NSArray *)params error:(NSError **)execError;
+
 @end
Index: contrib/MacPorts_Framework/MPPort.m
===================================================================
--- contrib/MacPorts_Framework/MPPort.m	(revision 40518)
+++ contrib/MacPorts_Framework/MPPort.m	(revision 65491)
@@ -99,4 +99,8 @@
 		[self setObject:[interpreter arrayFromTclListAsString:[self objectForKey:@"categories"]] forKey:@"categories"];
 	}
+	if ([self objectForKey:@"variants"] != nil) {
+		[self setObject:[self objectForKey:@"variants"] forKey:@"variantsAsString"];
+		[self setObject:[interpreter arrayFromTclListAsString:[self objectForKey:@"variants"]] forKey:@"variants"];
+	}
 	if ([self objectForKey:@"depends_build"] != nil) {
 		[self setObject:[self objectForKey:@"depends_build"] forKey:@"depends_buildAsString"];
@@ -116,6 +120,6 @@
 	
 	@try {
-		if ([[self valueForKey:@"long_description"] characterAtIndex:0] == '{') {
-			[self setValue:[self valueForKey:@"description"] forKey:@"long_description"];
+		if ([[self valueForKey:@"description"] characterAtIndex:0] == '{') {
+			[self setValue:[self valueForKey:@"description"] forKey:@"description"];
 		}
 	} 
@@ -125,5 +129,20 @@
 														  @"Localizable",
 														  [NSBundle mainBundle],
-														  @"Port has an invalid desciption or long_description key.",
+														  @"Port has an invalid desciption key.",
+														  @"Error statement for exception raised when testing description.")]
+				forKey:@"description"];
+	}
+	
+	@try {
+		if ([[self valueForKey:@"long_description"] characterAtIndex:0] == '{') {
+			[self setValue:[self valueForKey:@"long_description"] forKey:@"long_description"];
+		}
+	} 
+	@catch (NSException *e) {
+		[self setValue:[NSString stringWithFormat:
+						NSLocalizedStringWithDefaultValue(@"setPortWithTclListAsStringDescreiptionError",
+														  @"Localizable",
+														  [NSBundle mainBundle],
+														  @"Port has an invalid long_description key.",
 														  @"Error statement for exception raised when testing long_description.")]
 				forKey:@"long_description"];
@@ -212,5 +231,11 @@
 													error:execError];		
 	}
-	
+    // I must get the new state of the port from the registry
+	// instead of just [self setState:MPPortStateLearnState];
+    //NSArray *receipts  = [[[MPRegistry sharedRegistry] installed:[self name]] objectForKey:[self name]];
+    //[self setStateFromReceipts:receipts];
+    [self removeObjectForKey:@"receipts"];
+    [self setState:MPPortStateLearnState];
+    
 	[[MPNotifications sharedListener] setPerformingTclCommand:@""];
 	[self sendGlobalExecNotification:procedure withStatus:@"Finished"];
@@ -242,21 +267,12 @@
 	[[MPNotifications sharedListener] setPerformingTclCommand:target];
 	
-	if ([parentMacPortsInstance authorizationMode]) {
-		[interpreter evaluateStringWithMPHelperTool:
-		 [NSString stringWithFormat:
-		  @"set portHandle [mportopen  %@  %@  %@]; mportexec  $portHandle %@; mportclose $portHandle", 
-		  [self valueForKey:@"porturl"], opts, vrnts, target]
-												error:execError];
-	}
-	else {
-		[interpreter evaluateStringWithPossiblePrivileges:
-		 [NSString stringWithFormat:
-		  @"set portHandle [mportopen  %@  %@  %@]; mportexec  $portHandle %@; mportclose $portHandle", 
-		  [self valueForKey:@"porturl"], opts, vrnts, target]
-													error:execError];
-	}
-	
-	
-	
+    [interpreter evaluateStringWithPossiblePrivileges:
+        [NSString stringWithFormat:
+            @"set portHandle [mportopen  %@  %@  %@]; mportexec  $portHandle %@; mportclose $portHandle", 
+            [self valueForKey:@"porturl"], opts, vrnts, target]
+        error:execError];
+	
+	
+	[self setState:MPPortStateLearnState];
 	[[MPNotifications sharedListener] setPerformingTclCommand:@""];
 	[self sendGlobalExecNotification:target withStatus:@"Finished"];
@@ -332,4 +348,8 @@
 }
 
+- (void)upgradeWithError:(NSError **)mError {
+	[self execPortProc:@"mportupgrade" withOptions:nil version:@"" error:mError];
+}
+
 -(void)configureWithOptions:(NSArray *)options variants:(NSArray *)variants error:(NSError **)mError {
 	[self exec:@"configure" withOptions:options variants:variants error:mError];
@@ -384,4 +404,5 @@
 }
 
+
 # pragma mark -
 
@@ -391,5 +412,10 @@
 - (id)objectForKey:(id)aKey {
 	if ([aKey isEqualToString:@"receipts"] && ![super objectForKey:aKey]) {
-		[self setObject:[[[MPRegistry sharedRegistry] installed:[self objectForKey:@"name"]] objectForKey:[self objectForKey:@"name"]]forKey:aKey];
+        NSArray *receipts = [[[MPRegistry sharedRegistry] installed:[self objectForKey:@"name"]] objectForKey:[self objectForKey:@"name"]];
+        if (receipts == nil) {
+            return nil;
+        } else {
+            [self setObject:receipts forKey:aKey];
+        }
 	}
 	return [super objectForKey:aKey];
@@ -437,5 +463,5 @@
 
 - (void)setStateFromReceipts:(NSArray *)receipts {
-	[self setObject:receipts forKey:@"receipts"];
+    [self setObject:receipts forKey:@"receipts"];
 	[self setState:MPPortStateLearnState];
 }
Index: contrib/MacPorts_Framework/MPPortManipulationTest.m
===================================================================
--- contrib/MacPorts_Framework/MPPortManipulationTest.m	(revision 40518)
+++ contrib/MacPorts_Framework/MPPortManipulationTest.m	(revision 65491)
@@ -19,7 +19,9 @@
 	BOOL ret = NO;
 	
+	MPMacPorts * port = [MPMacPorts sharedInstanceWithPkgPath:@"/Users/juanger/Projects/gsoc09-gui/MPGUI/build/Debug-InstallMacPorts/macports-1.8/Library/Tcl"
+	 					portOptions:nil];
+	NSLog(@"PkgPath1:  %@", [MPInterpreter PKGPath]);
 	MPRegistry * registry = [MPRegistry sharedRegistry];
-	MPMacPorts * port = [MPMacPorts sharedInstance];
-	
+	NSLog(@"PkgPath2:  %@", [MPInterpreter PKGPath]);
 	// Check if portName is installed
 	unsigned int installed = [[registry installed:portName] count];
@@ -42,5 +44,5 @@
 			return ret;
 		}
-		
+		NSLog(@"Uninstallation Successful.");
 		//Uninstallation was successful ... now check registry to make sure its gone
 		installed = [[registry installed:portName] count];
@@ -68,7 +70,9 @@
 			return ret;
 		}
-		
+		NSLog(@"Installation successful");
 		//Installation was successful ... now check registry to make sure its gone
 		installed = [[registry installed:portName] count];
+        NSLog(@"%@", [registry installed]);
+        
 		if (installed == 0) { //Uh oh ... is this suppose to happen?
 			NSLog(@"%@ is not installed after successful install operation ... double check this from commandline", portName);
@@ -120,13 +124,14 @@
 //		
 //		
-//	}
+//	}	
 //	
 //	//Double check somehow
 //	MPRegistry * registry = [MPRegistry sharedRegistry];
 //	NSLog(@"\n\n Result from registry is %@ \n\n", [registry installed:[keyArray objectAtIndex:0]]);
-	
+
 	PortManipulator * pm = [[PortManipulator alloc] init];
 	STAssertTrue([pm installUninstallManipulation:@"pngcrush"] , @"This test should always return true on success");
 	[pm release];
+    
 }
 
Index: contrib/MacPorts_Framework/MPPortProcess.h
===================================================================
--- contrib/MacPorts_Framework/MPPortProcess.h	(revision 65491)
+++ contrib/MacPorts_Framework/MPPortProcess.h	(revision 65491)
@@ -0,0 +1,19 @@
+//
+//  MPPortProcess.h
+//  MacPorts.Framework
+//
+//  Created by Juan Germán Castañeda Echevarría on 7/9/09.
+//  Copyright 2009 UNAM. All rights reserved.
+//
+
+#include <tcl.h>
+
+@interface MPPortProcess : NSObject {
+    Tcl_Interp *interpreter;
+    NSString *PKGPath;
+}
+
+
+- (oneway void)evaluateString:(bycopy id)statement;
+
+@end
